//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 8
#property indicator_color1  Lime
#property indicator_color2  Lime
#property indicator_color3  Lime
#property indicator_color4  Lime
#property indicator_color5  Lime
#property indicator_color6  Lime
#property indicator_color7  Lime
#property indicator_color8  Lime

extern int    Period1 = 3;
extern int    Period2 = 5;
extern int    Period3 = 8;
extern int    Period4 = 10;
extern int    Period5 = 12;
extern int    Period6 = 15;
extern int    Period7 = 0;
extern int    Period8 = 0;
extern int    Prices  = PRICE_CLOSE;

double buffer1[];
double buffer2[];
double buffer3[];
double buffer4[];
double buffer5[];
double buffer6[];
double buffer7[];
double buffer8[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,buffer1);
   SetIndexBuffer(1,buffer2);
   SetIndexBuffer(2,buffer3);
   SetIndexBuffer(3,buffer4);
   SetIndexBuffer(4,buffer5);
   SetIndexBuffer(5,buffer6);
   SetIndexBuffer(6,buffer7);
   SetIndexBuffer(7,buffer8);
   return(0);
}
int deinit() { return(0); }
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //

   for(int i=limit; i>=0; i--)
   {
      double price = iMA(NULL,0,1,0,MODE_SMA,Prices,i);
        if (Period1>1) buffer1[i] = iTma(price,Period1,i,0);
        if (Period2>1) buffer2[i] = iTma(price,Period2,i,1);
        if (Period3>1) buffer3[i] = iTma(price,Period3,i,2);
        if (Period4>1) buffer4[i] = iTma(price,Period4,i,3);
        if (Period5>1) buffer5[i] = iTma(price,Period5,i,4);
        if (Period6>1) buffer6[i] = iTma(price,Period6,i,5);
        if (Period7>1) buffer7[i] = iTma(price,Period7,i,6);
        if (Period8>1) buffer8[i] = iTma(price,Period8,i,7);
   }      
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double workTma[][8];
double iTma(double price, double period, int r, int instanceNo=0)
{
   if (ArrayRange(workTma,0)!= Bars) ArrayResize(workTma,Bars); r = Bars-r-1;
   
   //
   //
   //
   //
   //
   
   workTma[r][instanceNo] = price;

      double half = (period+1.0)/2.0;
      double sum  = price;
      double sumw = 1;

      for(int k=1; k<period && (r-k)>=0; k++)
      {
         double weight = k+1; if (weight > half) weight = period-k;
                sumw  += weight;
                sum   += weight*workTma[r-k][instanceNo];  
      }             
      return(sum/sumw);
}

